﻿<Graph ClassName="PBBid" Source="#CDATA" IsNew="True" FileType="NewDac">
    <CDATA name="Source"><![CDATA[using System;
using PX.Data;
using PX.Objects.AR;
using PX.Objects.CR.Standalone;
using PX.Objects.IN;
using PX.TM;
using PX.Objects.CS;
using PX.Data.EP;
using PX.Data.ReferentialIntegrity.Attributes;
using PX.Objects.RQ;

namespace PBBidding
{
    [PXPrimaryGraph(typeof(PBBiddingEntry))]
    [Serializable]
    [PXEMailSource]
    [PXCacheName("Partial Bidding")]
    public class PBBid : IBqlTable, PX.Data.EP.IAssign
    {
        #region BidID
        [PXDBIdentity()]
        [PXUIField(DisplayName = "Bid ID")]
        public virtual int? BidID { get; set; }
        public abstract class bidID : PX.Data.BQL.BqlInt.Field<bidID> { }
        #endregion

        #region RefNbr
        [PXDBString(15, IsUnicode = true, InputMask = "", IsKey = true)]
        [PXSelector(typeof(Search<refNbr>))]
        [AutoNumber(typeof(RQSetupExtPB.usrBidNumberingID), typeof(AccessInfo.businessDate))]
        [PXUIField(DisplayName = "Reference Nbr.")]
        public virtual string RefNbr { get; set; }
        public abstract class refNbr : PX.Data.BQL.BqlString.Field<refNbr> { }
        #endregion

        #region Status
        [PXDBString(1, IsFixed = true, InputMask = "")]
        [BiddingStatus.List]
        [PXDefault(BiddingStatus.Hold)]
        [PXUIField(DisplayName = "Status", Enabled = false)]
        public virtual string Status { get; set; }
        public abstract class status : PX.Data.BQL.BqlString.Field<status> { }
        #endregion

        #region Description
        [PXDBString(100, InputMask = "")]
        [PXUIField(DisplayName = "Description")]
        [PXDefault()]
        [PXUIEnabled(typeof(
            Where<status, NotEqual<BiddingStatus.closed>>))]
        public virtual string Description { get; set; }
        public abstract class description : PX.Data.BQL.BqlString.Field<description> { }
        #endregion
          
        #region Remarks
        [PXDBString(250, InputMask = "")]
        [PXUIField(DisplayName = "Remarks")]
        public virtual string Remarks { get; set; }
        public abstract class remarks : PX.Data.BQL.BqlString.Field<remarks> { }
        #endregion  

        #region LineCntr
        [PXDBInt()]
        [PXDefault(0)]
        [PXUIField(DisplayName = "Line Cntr")]
        public virtual int? LineCntr { get; set; }
        public abstract class lineCntr : PX.Data.BQL.BqlInt.Field<lineCntr> { }
        #endregion

        #region StartDate
        [PXDBDate()]
        [PXDefault(typeof(AccessInfo.businessDate))]
        [PXUIField(DisplayName = "Start Date")]
        public virtual DateTime? StartDate { get; set; }
        public abstract class startDate : PX.Data.BQL.BqlDateTime.Field<startDate> { }
        #endregion

        #region EndDate
        [PXDBDate()]
        [PXUIVisible(typeof(
            Where<endDate, IsNotNull>))]
        [PXUIField(DisplayName = "End Date")]
        public virtual DateTime? EndDate { get; set; }
        public abstract class endDate : PX.Data.BQL.BqlDateTime.Field<endDate> { }
        #endregion

       
        /* IAssign Fields*/
        #region WorkgroupID
        public abstract class workgroupID : PX.Data.BQL.BqlInt.Field<workgroupID> { }
    protected int? _WorkgroupID;
    [PXInt]    
    [PXSelector(typeof(Search<EPCompanyTree.workGroupID>), SubstituteKey = typeof(EPCompanyTree.description))]
    [PXUIField(DisplayName = "Approval Workgroup ID", Enabled=false)]
    public virtual int? WorkgroupID
    {
      get
      {
        return this._WorkgroupID;
      }
      set
      {
        this._WorkgroupID = value;
      }
    }
    #endregion
    #region OwnerID
    public abstract class ownerID : PX.Data.BQL.BqlInt.Field<ownerID> { }
    protected int? _OwnerID;
    [Owner(IsDBField = false, DisplayName = "Approver", Enabled = false)]
    public virtual int? OwnerID
    {
      get
      {
        return this._OwnerID;
      }
      set
      {
        this._OwnerID = value;
      }
    }
    #endregion

        #region Approved
        [PXDBBool()]
        [PXDefault(false, PersistingCheck = PXPersistingCheck.Nothing)]
        [PXUIField(DisplayName = "Approved", Visibility = PXUIVisibility.Visible, Enabled = false)]
        public virtual bool? Approved { get; set; }
        public abstract class approved : PX.Data.BQL.BqlBool.Field<approved> { }
        #endregion

        #region Rejected
        [PXBool]
        [PXDefault(false, PersistingCheck = PXPersistingCheck.Nothing)]
        [PXUIField(DisplayName = "Rejected")]
        public virtual bool? Rejected { get; set; }
        public abstract class rejected : PX.Data.BQL.BqlBool.Field<rejected> { }
        #endregion

        #region Hold
        [PXDBBool]
        [PXDefault(false, PersistingCheck = PXPersistingCheck.Nothing)]
        [PXUIField(DisplayName = "Hold")]
        public virtual bool? Hold { get; set; }
        public abstract class hold : PX.Data.BQL.BqlBool.Field<hold> { }
        #endregion

        #region RequestApproval
        [PXBool()]
        [PXDefault(false, PersistingCheck = PXPersistingCheck.Nothing)]
        [PXUIField(DisplayName = "Request Approval", Visible = true)]
        public virtual bool? RequestApproval { get; set; }
        public abstract class requestApproval : PX.Data.BQL.BqlBool.Field<requestApproval> { }
        #endregion

        #region NoteID
        [PXNote]
        [PXUIField(DisplayName = "Note ID")]
        public virtual Guid? NoteID { get; set; }
        public abstract class noteID : PX.Data.BQL.BqlGuid.Field<noteID> { }
        #endregion
        #region CreatedByID
        public abstract class createdByID : PX.Data.BQL.BqlGuid.Field<createdByID> { }
        protected Guid? _CreatedByID;
        [PXDBCreatedByID()]
        public virtual Guid? CreatedByID
        {
            get
            {
                return this._CreatedByID;
            }
            set
            {
                this._CreatedByID = value;
            }
        }
        #endregion
        #region CreatedByScreenID
        public abstract class createdByScreenID : PX.Data.BQL.BqlString.Field<createdByScreenID> { }
        protected String _CreatedByScreenID;
        [PXDBCreatedByScreenID()]
        public virtual String CreatedByScreenID
        {
            get
            {
                return this._CreatedByScreenID;
            }
            set
            {
                this._CreatedByScreenID = value;
            }
        }
        #endregion
        #region CreatedDateTime
        public abstract class createdDateTime : PX.Data.BQL.BqlDateTime.Field<createdDateTime> { }
        protected DateTime? _CreatedDateTime;
        [PXDBCreatedDateTime]
        [PXUIField(DisplayName = PXDBLastModifiedByIDAttribute.DisplayFieldNames.CreatedDateTime, Enabled = false, IsReadOnly = true)]
        public virtual DateTime? CreatedDateTime
        {
            get
            {
                return this._CreatedDateTime;
            }
            set
            {
                this._CreatedDateTime = value;
            }
        }
        #endregion
        #region LastModifiedByID
        public abstract class lastModifiedByID : PX.Data.BQL.BqlGuid.Field<lastModifiedByID> { }
        protected Guid? _LastModifiedByID;
        [PXDBLastModifiedByID()]
        public virtual Guid? LastModifiedByID
        {
            get
            {
                return this._LastModifiedByID;
            }
            set
            {
                this._LastModifiedByID = value;
            }
        }
        #endregion
        #region LastModifiedByScreenID
        public abstract class lastModifiedByScreenID : PX.Data.BQL.BqlString.Field<lastModifiedByScreenID> { }
        protected String _LastModifiedByScreenID;
        [PXDBLastModifiedByScreenID()]
        public virtual String LastModifiedByScreenID
        {
            get
            {
                return this._LastModifiedByScreenID;
            }
            set
            {
                this._LastModifiedByScreenID = value;
            }
        }
        #endregion
        #region LastModifiedDateTime
        public abstract class lastModifiedDateTime : PX.Data.BQL.BqlDateTime.Field<lastModifiedDateTime> { }
        protected DateTime? _LastModifiedDateTime;
        [PXDBLastModifiedDateTime]
        [PXUIField(DisplayName = PXDBLastModifiedByIDAttribute.DisplayFieldNames.LastModifiedDateTime, Enabled = false, IsReadOnly = true)]
        public virtual DateTime? LastModifiedDateTime
        {
            get
            {
                return this._LastModifiedDateTime;
            }
            set
            {
                this._LastModifiedDateTime = value;
            }
        }
        #endregion
        #region tstamp
        public abstract class Tstamp : PX.Data.BQL.BqlByteArray.Field<Tstamp> { }
        protected Byte[] _tstamp;
        [PXDBTimestamp()]
        public virtual Byte[] tstamp
        {
            get
            {
                return this._tstamp;
            }
            set
            {
                this._tstamp = value;
            }
        }
        #endregion
    }

    public abstract class BiddingStatus : IBqlField
    {
        public class ListAttribute : PXStringListAttribute
        {
            public ListAttribute()
                : base(
                new string[] { Hold, PendingApproval, Open, Canceled,  Closed, Rejected },
                new string[] { UI.Hold, UI.PendingApproval, UI.Open, UI.Canceled, UI.Closed, UI.Rejected })
            { }
        }

        public const string Pending = "P";

        public const string Hold = "H";
        public const string PendingApproval = "N";
        public const string Open = "O";
        public const string Closed = "C";
        public const string Canceled = "X";
        public const string Rejected = "R";

        public class UI
        {
            public const string Pending = "Pending Bidding";

            /* New statuses */
            public const string Hold = "On Hold";
            public const string PendingApproval = "Pending Approval";
            public const string Open = "Open";
            public const string Closed = "Closed";
            public const string Canceled = "Canceled";
            public const string Rejected = "Rejected";

        }
        
        public class pending : Constant<string>
        {
            public pending() : base(Pending) { }
        }

        /* New statuses */
        public class hold : Constant<string>
        {
            public hold() : base(Hold) { }
        }
        public class open : Constant<string>
        {
            public open() : base(Open) { }
        }
        public class closed : Constant<string>
        {
            public closed() : base(Closed) { }
        }
        public class canceled : Constant<string>
        {
            public canceled() : base(Canceled) { }
        }
    }
          
    public static class CustomAssignmentMapType
    {
      public class PBBidType : PX.Data.BQL.BqlString.Constant<PBBidType>
      {
        public PBBidType() : base(typeof(PBBid).FullName) { }
      }
    } 
}]]></CDATA>
</Graph>